//Hervest etc PAC Archive
#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <string.h>

unsigned long decodeLZ( FILE *in, unsigned long size, FILE *out )
{
	unsigned char	buf[256];
	unsigned char	*dic;
	unsigned long	dicpos = 0x0FEE;
	unsigned char	byte;
	unsigned char	sign;
	unsigned int	counter;
	unsigned int	decode_startaddr;
	unsigned int	decode_length;
	int				i;
	int				q;
	unsigned long	decode_byte = 0L;
	unsigned long	read_byte = 0L;
	unsigned long	addr = 0L;

	dic = ( unsigned char * )calloc( 1, 4096 );

	while( read_byte < size )
	{
		//compress sign
		fread( buf, 1, 1, in ); sign = buf[0];
		read_byte++;

		for( i = 0; i != 8; i++ )
		{
			if( sign & 1 )
			{
				fread( buf, 1, 1, in ); byte = buf[0];
				dic[dicpos] = byte;
				fprintf( out, "%c", byte );
				dicpos++; dicpos &= 0x0FFF;
				read_byte++; decode_byte++;
			} else {
				fread( buf, 2, 1, in );
				decode_length = ( buf[1] & 0x0F ) + 0x03;
				decode_startaddr  = ( buf[1] & 0xF0 ) << 4;
				decode_startaddr += ( buf[0] );
				read_byte += 2;

				//decode
				for( q = 0; q != decode_length; q++ )
				{
					addr = decode_startaddr + q; addr &= 0x0FFF;
					dic[dicpos] = dic[addr];
					fprintf( out, "%c", dic[addr] );
					dicpos++; dicpos &= 0x0FFF;
					decode_byte++;
				}
			}
			sign >>= 1;
			if( read_byte > size ) break;
		}
	}
	free( dic );
	return decode_byte;
}

void getfileext( char *src, char *ext )
{
	int	i;
	int	len;

	len = strlen( src );

	for( i = len; i > 0; i-- )
	{
		if( src[i] == '.' ) break;
	}
	i++;

	strcpy( ext, &src[i] );
	return;
}

void main( int ac, char **av )
{
	FILE				*in;
	FILE				*out;
	unsigned char		tmp[12];
	unsigned char		*buf;
	unsigned char		*filebuf;
	unsigned long		header_length = 0L;
	unsigned int		file_count = 0;
	unsigned long		file_ed = 0L;

	char				index_filename[12];
	char				header_filename[12];
	char				ext[3];
	unsigned long		header_filest = 0L;
	unsigned long		header_fileed = 0L;
	unsigned long		header_filesize = 0L;

	unsigned long		nowsize = 0L;

	unsigned int		i;

	int					lz = 1;
	unsigned char		lz_offset = 0x0A;

	printf( "Hervest/etc PAC Divider 060812 (c)Fac.KUROHANE\n" );

	if( ac == 1 )
	{
		printf( "usage: PACVDIV <filename>\n" );
		return;
	}

	getfileext( av[1], ext );

	if( strcmpi( ext, "PAC" ) != 0 )
	{
		printf( "error: not PAC format.\n" );
		return;
	}

	in = fopen( av[1], "rb" );
	if( in == NULL )
	{
		printf( "error: can't open %s\n", av[1] );
		return;
	}

	if( strcmpi( av[2], "/nd" ) == 0 ) lz = 0;

	printf( "filename: %s\n", av[1] );

	fseek( in, 0x00, SEEK_SET );
	fread( tmp, 2, 1, in );

	//file_count
	file_count = *( unsigned int * )( tmp );
	printf( "file_count: %u\n", file_count );

	//filesize
	fseek( in, 0, SEEK_END );
	file_ed = ftell( in );
	fseek( in, 0, SEEK_SET );
	printf( "file_size: %lu(%04lX)\n", file_ed, file_ed );

	//Header size
	header_length = file_count * 0x20 + 0x10;
	printf( "header_length: %lu(%04lX)\n",
		header_length,
		header_length
	);

	//Read Header
	buf = ( unsigned char *)calloc( 1, header_length - 0x10 );
	fseek( in, 0x10, SEEK_SET );
	fread( buf, header_length - 0x10, 1, in );

	printf( "\n" );

	for( i = 0; i != file_count; i++ )
	{
		int		flag = 0;

		memset( header_filename, 0, sizeof( header_filename ) + 1 );
		memset( ext, 0, sizeof( ext ));

		memcpy( header_filename, &buf[i*0x20], 12 );

		getfileext( header_filename, ext );

		header_filest = *( unsigned long *)( buf + ( i * 0x20 ) + 0x10 );
		header_filest += header_length;
		header_filesize = *( unsigned long *)( buf + ( i * 0x20 ) + 0x14 );
		header_fileed = header_filest + header_filesize;

		printf( "%03d %-12s %08lX-%08lX (%lu)",
			i + 1,
			header_filename,
			header_filest,
			header_fileed,
			header_filesize
		);

		if( strcmpi( ext, "O" ) == 0 ) flag = 1;
		if( strcmpi( ext, "O26" ) == 0 ) flag = 1;
		if( strcmpi( ext, "O86" ) == 0 ) flag = 1;
		if( strcmpi( ext, "OOO" ) == 0 ) flag = 1;
		if( strcmpi( ext, "INT" ) == 0 ) flag = 1;

		if( flag != 1 )
		{
			printf( " skip\n" );
			continue;
		}

		out = fopen( header_filename, "wb" );
		if( out == NULL )
		{
			printf( "error: can't write %s\n", header_filename );
			goto end;
		}

		if( lz == 1 )
		{
			//decode
			fseek( in, header_filest + lz_offset, SEEK_SET );
			nowsize = decodeLZ( in, header_filesize - lz_offset, out );
			printf( " -> (%lu)\n", nowsize );
		} else {
			fseek( in, header_filest, SEEK_SET );

			filebuf = ( unsigned char * )calloc( 1, 32768 );	//32k
			nowsize = header_filesize;

			while( !( nowsize < 32769 ))
			{
				fread( filebuf, 32768, 1, in );
				fwrite( filebuf, 32768, 1, out );
				nowsize -= 32768;
				printf( "." );
			}
			fread( filebuf, nowsize, 1, in );
			fwrite( filebuf, nowsize, 1, out );

			printf( ".\n" );
			free( filebuf );
		}
		fclose( out );
	}
	printf( "\n" );
	printf( "complete.\n" );

end:;
	free( buf );
end2:;
	fclose( in );
	return;
}
